using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace _17230
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	/// 
	
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			
			// Setup custom summaries
			this.gridGroupingControl1.QueryCustomSummary += new Syncfusion.Windows.Forms.Grid.Grouping.GridQueryCustomSummaryEventHandler(gridGroupingControl1_QueryCustomSummary);

			GridSummaryColumnDescriptor sd = new GridSummaryColumnDescriptor();
			sd.Name = "WeightedAverage";
			sd.DataMember = "W";
			sd.DisplayColumn = "W";
			sd.Format = "{WeightedAverage: #.##}";;
			sd.SummaryType = SummaryType.Custom;
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(new GridSummaryRowDescriptor("SumaaryRow","Weighted Mean: ", sd));

			this.gridGroupingControl1.DataSource = this.GetTable();

			this.gridGroupingControl1.TableDescriptor.Columns[0].Width = 100;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(320, 264);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.62";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 278);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable GetTable()
		{
			DataTable dt = new DataTable();
			DataColumn col = new DataColumn("X");
			dt.Columns.Add(col);
			col = new DataColumn("W");
			dt.Columns.Add(col);

			Random r = new Random();
			for(int i =0;i<10;i++)
			{
				DataRow row = dt.NewRow();
				for(int j=0;j<2;j++)
					row[j] = r.Next(100);//j+1;
				dt.Rows.Add(row);
			}

			return dt;
		}

		private void gridGroupingControl1_QueryCustomSummary(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridQueryCustomSummaryEventArgs e)
		{
			if(e.SummaryColumn.Name == "WeightedAverage")
					e.SummaryDescriptor.CreateSummaryMethod = new CreateSummaryDelegate(WeightedAverageSummary.CreateSummaryMethod);
		}
	}


}
